#include <windows.h>
#include <shlwapi.h>

#include "../include/swr.h"

#ifndef _DEBUG
extern "C"
int _fltused = 1;
#endif

#define CSelectSV_Create(p) \
	Ccall(p, s_origCSelectSV_Create, void, ())()
#define CSelectSV_Render(p) \
	Ccall(p, s_origCSelectSV_Render, int, ())()
#define CSelectCL_Create(p) \
	Ccall(p, s_origCSelectCL_Create, void, ())()
#define CSelectCL_Render(p) \
	Ccall(p, s_origCSelectCL_Render, int, ())()
#define CSelect_Create(p) \
	Ccall(p, s_origCSelect_Create, void, ())()
#define CSelect_Render(p) \
	Ccall(p, s_origCSelect_Render, int, ())()
#define CSelect_Destruct(p) \
	Ccall(p, s_origCSelect_Destruct, void, ())()

#define Hiiro_LoadPalette \
	((bool (*)(void *pal, int id, int set, int offset))((char *)s_hHiiro + 0x1310))

static HMODULE s_hHiiro;
static BYTE s_paletteIdMap[2][15];

static DWORD s_origCSelectSV_Create;
static DWORD s_origCSelectSV_Render;
static DWORD s_origCSelectCL_Create;
static DWORD s_origCSelectCL_Render;
static DWORD s_origCSelect_Create;
static DWORD s_origCSelect_Render;
static DWORD s_origCSelect_Destruct;
static DWORD s_origCSelect_Size;

void CSelect_ReloadSelectStandEffect(void *This, int id, int set, int offset)
{
	char buff[260];
	// ܂1PWpbg[h(paletterƐݒ肳悤ɁB)
	wsprintf(buff, "data/scene/select/character/%s/palette%03d.bmp",
		GetCharacterAbbr(id), 0);
	LoadPackagePalette(&g_useCVxData, buff, &g_paletter, 0x10);

	char *palbuff = *(char **)(&g_paletter + 1);
	if(set == 99) {
		// _̓VGbgɂႤ
		WORD *wpalbuff = (WORD *)palbuff;
		for(int i = 0; i < 256; ++i)
			wpalbuff[i] &= 0x8000;
	} else
	// Fpbg[hā`
	if(Hiiro_LoadPalette(palbuff, id, set, 0xFFFFFFFF))
	{
		// XNuāAƁB
		for(int i = 0; i < 0x200; ++i)
			palbuff[i] ^= 0xFF;
	}

	// ׂ
	IEffectManager *em = (IEffectManager*)
		((char*)This + offset + id * 0x94 * 2);
	em->Destruct(0);
	CSelectEffectManager_Create(em);

	// L̗p^[[h
	wsprintf(buff, "data/scene/select/character/%s/stand.pat",
		GetCharacterAbbr(id));
	em->LoadPattern(buff, 0);
	// 1PGtFNg
	float Baxis = (*(UnknownF**)((char*)This + 0x604))->Baxis + 8.0f;
	float Aaxis = (*(UnknownF**)((char*)This + 0x604))->Aaxis + 32.0f; 
	em->AppendRegion(0, Aaxis, Baxis, 1, 0, 0);
	// 2PGtFNg
	Baxis = (*(UnknownF**)((char*)This + 0x608))->Baxis + 8.0f;
	Aaxis = (*(UnknownF**)((char*)This + 0x608))->Aaxis + 32.0f; 
	em->AppendRegion(0, Aaxis, Baxis, 1, 1, 0);
}

void * __fastcall CSelectCommon_OnCreate(void *This)
{

	// 2PGZbg
	char *p2Effect = (char *)This + s_origCSelect_Size;
	Vector_Create(p2Effect, 0x94, 0x1E,
		CSelectEffectManager_Create_Address,
		CSelectEffectManager_Free_Address);

	char buff[260];
	for(int i = 0; i < 15; ++i) {
		// 1Ppbg[h
		wsprintf(buff, "data/scene/select/character/%s/palette%03d.bmp",
			GetCharacterAbbr(i), 0);
		LoadPackagePalette(&g_useCVxData, buff, &g_paletter, 0x10);

		// L̗p^[[h
		wsprintf(buff, "data/scene/select/character/%s/stand.pat",
			GetCharacterAbbr(i));
		IEffectManager *em = (IEffectManager *)(p2Effect + i * 0x94 * 2);
		em->LoadPattern(buff, 0);
		// 1PGtFNg
		float Baxis = (*(UnknownF**)((char*)This + 0x604))->Baxis + 8.0f;
		float Aaxis = (*(UnknownF**)((char*)This + 0x604))->Aaxis + 32.0f; 
		em->AppendRegion(0, Aaxis, Baxis, 1, 0, 0);
		// 2PGtFNg
		Baxis = (*(UnknownF**)((char*)This + 0x608))->Baxis + 8.0f;
		Aaxis = (*(UnknownF**)((char*)This + 0x608))->Aaxis + 32.0f; 
		em->AppendRegion(0, Aaxis, Baxis, 1, 1, 0);
	}

	// F`H
	s_hHiiro = GetModuleHandle("papp.dll");

	// pbgID}bv
	memset(s_paletteIdMap, 0, sizeof(s_paletteIdMap));

	return This;
}

void * __fastcall CSelectSV_OnCreate(void *This)
{
	// super
	CSelectSV_Create(This);
	return CSelectCommon_OnCreate(This);
}

void * __fastcall CSelectCL_OnCreate(void *This)
{
	// super
	CSelectCL_Create(This);
	return CSelectCommon_OnCreate(This);
}

void * __fastcall CSelect_OnCreate(void *This)
{
	// super
	CSelect_Create(This);
	return CSelectCommon_OnCreate(This);
}

void __fastcall CSelect_OnDestruct(void *This)
{
	// 2PGZbĝĂ
	char *p2Effect = (char *)This + s_origCSelect_Size;
	Vector_Destruct(p2Effect, 0x94, 0x1E,
		CSelectEffectManager_Free_Address);

	// super
	CSelect_Destruct(This);

}

void __fastcall CSelectCommon_OnRender(void *This)
{
	// FAݒɏ]ăJpς
	if(s_hHiiro) {
		int p1set = *(char*)((char *)s_hHiiro + 0x3188);
		if(
		g_leftCharID != 0xF &&
		s_paletteIdMap[0][g_leftCharID] != p1set) {
			s_paletteIdMap[0][g_leftCharID] = p1set;
			CSelect_ReloadSelectStandEffect(
				This, g_leftCharID, p1set, 0x7FC);
		}
		int p2set = *(char*)((char *)s_hHiiro + 0x3189);
		if(
		g_rightCharID != 0xF &&
		s_paletteIdMap[1][g_rightCharID] != p2set) {
			s_paletteIdMap[1][g_rightCharID] = p2set;
			CSelect_ReloadSelectStandEffect(
				This, g_rightCharID, p2set, s_origCSelect_Size);
		}
	}
}

int __fastcall CSelectSV_OnRender(void *This)
{
	// super
	int ret = CSelectSV_Render(This);
	CSelectCommon_OnRender(This);
	return ret;
}

int __fastcall CSelectCL_OnRender(void *This)
{
	// super
	int ret = CSelectCL_Render(This);
	CSelectCommon_OnRender(This);
	return ret;
}

int __fastcall CSelect_OnRender(void *This)
{
	// super
	int ret = CSelect_Render(This);
	CSelectCommon_OnRender(This);
	return ret;
}

void __declspec(naked) CSelect_OnChangeCharacter()
{
	__asm {
		test edi, edi
		jnz p2
p1:		lea eax, [esi+ebp+7FCh]
		jmp ep
p2:		mov eax, s_origCSelect_Size
		lea eax, [esi+eax]
		lea eax, [ebp+eax]
ep:		push 0x41F060
		retn
	}
}

BOOL Hook()
{
	// 
	DWORD old;
	::VirtualProtect((PVOID)text_Offset, text_Size, PAGE_EXECUTE_WRITECOPY, &old);
	s_origCSelect_Size = max(CSelect_Size, CSelectSV_Size);
	s_origCSelect_Size = max(s_origCSelect_Size, CSelectCL_Size);
	CSelect_Size =
	CSelectSV_Size =
	CSelectCL_Size = s_origCSelect_Size + 0x94 * 0x1E;

	s_origCSelectSV_Create = TamperNearJmpOpr(
		CSelectSV_Creater, union_cast<DWORD>(CSelectSV_OnCreate));
	s_origCSelectCL_Create = TamperNearJmpOpr(
		CSelectCL_Creater, union_cast<DWORD>(CSelectCL_OnCreate));
	s_origCSelect_Create = TamperNearJmpOpr(
		CSelect_Creater, union_cast<DWORD>(CSelect_OnCreate));

	// SĂSelectĂ̂ł̒RXg̕
	s_origCSelect_Destruct = TamperNearJmpOpr(
		0x41DC03, union_cast<DWORD>(CSelect_OnDestruct));

	// ΂́cc
	TamperNearJmp(0x41F059, union_cast<DWORD>(CSelect_OnChangeCharacter));
	::VirtualProtect((PVOID)text_Offset, text_Size, old, &old);

	::VirtualProtect((PVOID)rdata_Offset, rdata_Size, PAGE_EXECUTE_WRITECOPY, &old);
	s_origCSelectSV_Render = TamperDword(
		vtbl_CSelectSV + 0x08, union_cast<DWORD>(CSelectSV_OnRender));
	s_origCSelectCL_Render = TamperDword(
		vtbl_CSelectCL + 0x08, union_cast<DWORD>(CSelectCL_OnRender));
	s_origCSelect_Render = TamperDword(
		vtbl_CSelect + 0x08, union_cast<DWORD>(CSelect_OnRender));
	::VirtualProtect((PVOID)rdata_Offset, rdata_Size, old, &old);

	::FlushInstructionCache(GetCurrentProcess(), NULL, 0);
	return TRUE;
}

extern "C"
int APIENTRY DllMain(HMODULE hModule, DWORD fdwReason, LPVOID lpReserved)
{
	return (fdwReason == DLL_PROCESS_ATTACH) ? Hook() : TRUE;
}
