#ifndef SWR_H_INCLUDED
#define SWR_H_INCLUDED

// ---------------- ev ----------------

// DWORD
__inline
DWORD TamperDword(DWORD addr, DWORD target)
{
	DWORD old = *(DWORD*)addr;
	*(DWORD*)addr = target;
	return old;
}

// DWORDZ
__inline
DWORD TamperDwordAdd(DWORD addr, DWORD delta)
{
	DWORD old = *(DWORD*)addr;
	*(DWORD*)addr += delta;
	return old;
}

// NEAR JMPIyh
__inline
DWORD TamperNearJmpOpr(DWORD addr, DWORD target)
{
	DWORD old = *(DWORD*)(addr + 1) + (addr + 5);
	*(DWORD*)(addr + 1) = target - (addr + 5);
	return old;
}

// NEAR JMP
__inline
void TamperNearJmp(DWORD addr, DWORD target)
{
	*(PBYTE)(addr + 0) = 0xE9;
	TamperNearJmpOpr(addr, target);
}

// NEAR CALL
__inline
void TamperNearCall(DWORD addr, DWORD target)
{
	*(PBYTE)(addr + 0) = 0xE8;
	TamperNearJmpOpr(addr, target);
}

// tHgfBXNv^
#pragma pack(push, 4)
struct SWRFONTDESC {
	char FaceName[0x100];
	BYTE R1;
	BYTE R2;
	BYTE G1;
	BYTE G2;
	BYTE B1;
	BYTE B2;
	LONG Height;
	LONG Weight;
	BYTE Italic;
	BYTE Shadow;
	BYTE UseOffset;
	DWORD BufferSize;
	DWORD OffsetX;
	DWORD OffsetY;
	DWORD CharSpaceX;
	DWORD CharSpaceY;
};

// RpNg
struct SWRSTR {
	union {
		char  str[16];
		char* pstr;
	};
	size_t length;

	operator char *() {
		return length > 15 ? pstr : str;
	}
};

// GtFNg}l[WC^[tF[X
struct IEffectManager {
	virtual void* Destruct(int dynamic) = 0;
	virtual void LoadPattern(LPCSTR fileName, int) = 0;
	virtual void ClearPattern() = 0;
	virtual void AppendRegion(int arg_0, float arg_4, float arg_8, char arg_c, char arg_10, int arg_14) = 0;
	virtual void ClearRegion() = 0;
};

// 悭킩Ȃ
struct UnknownF {
	void *Unknown[3];
	float Aaxis;
	float Baxis;
};

// static_assert
template<bool value>
struct static_assert { typedef struct assert_failed Type; };
template<>
struct static_assert<true> { typedef void* Type; };

// union_cast
template<typename TDest, typename TSrc>
__forceinline 	
TDest union_cast(TSrc src) {
	static_assert<sizeof(TDest) == sizeof(TSrc)>::Type 
		size_mismatch = 0;
	union {  TDest dst; TSrc src; } c;
	c.src = src;
	return c.dst;
}

// thiscall
class C {};
#define Ccall(p,f,r,T) (((C*)p)->*union_cast<r##(C::*)##T>(f))

// tHgIuWFNg\bh
#define SWRFont_Create(p) \
	Ccall(p,0x410DA0,void,())()
#define SWRFont_Destruct(p) \
	Ccall(p,0x410E30,void,())()
#define SWRFont_SetIndirect(p, pdesc) \
	Ccall(p,0x410F10,void,(void*))(pdesc)

// eNX`}l[W\bh
#define CTextureManager_LoadTexture(p, ret, path, unk1, unk2) \
	Ccall(p,0x404EC0,int*,(int*, LPCSTR, void*, void*))(ret, path, unk1, unk2)
#define CTextureManager_CreateTextTexture(p, ret, str, pdesc ,width ,height) \
	Ccall(p,0x404F30,int*,(int*, LPCSTR, void*, int, int))(ret, str, pdesc, width, height)
#define CTextureManager_Remove(p, id) \
	Ccall(p,0x404FA0,void*,(int))(id)
#define CTextureManager_SetTexture(p, id, stage) \
	Ccall(p,0x405020,void,(int, int))(id, stage)
#define CTextureManager_GetSize(p, w, h) \
	Ccall(p,0x405090,void,(int*, int*))(w, h)
// eNX`}l[W\bh(nh}l[W̌p)
#define CTextureManager_Get(p, id) \
	((IDirect3DTexture9**)CHandleManager_Get(p, id))
#define CTextureManager_Allocate(p, id) \
	((IDirect3DTexture9**)CHandleManager_Allocate(p, id))
#define CTextureManager_Deallocate(p, id) \
	CHandleManager_Deallocate((void *)p, id)

// nh}l[W\bh
#define CHandleManager_Get(t, p, id) \
	Ccall(p,0x417010,t*,(int))(id)
 __declspec(naked) void**
Thunk_CHandleManager_Allocate(void *p, int *ret) {
	// thiscallȂ̂ɗƎvedigĂł@̊
	__asm push edi
	__asm mov edi, [esp+8]
	__asm push [esp+12]
	__asm mov eax, 0x402680
	__asm call eax
	__asm pop edi
	__asm retn
}
#define CHandleManager_Allocate(p, ret) \
	Thunk_CHandleManager_Allocate(p, ret)
 __declspec(naked) void
Thunk_CHandleManager_Deallocate(void *p, int id) {
	 // thiscall()eaxgĂł@̊
	__asm mov eax, [esp+4]
	__asm push [esp+8]
	__asm mov ecx, 0x4027F0
	__asm call ecx
	__asm retn
}
#define CHandleManager_Deallocate(p, id) \
	Thunk_CHandleManager_Deallocate(p, id)

// _\bh
#define CRenderer_Begin(p)  \
	Ccall(p,0x401000,bool,())()
#define CRenderer_End(p) \
	Ccall(p,0x401040,void,())()

// ZNgGtFNg}l[W\bh
#define CSelectEffectManager_Create_Address 0x420CE0
#define CSelectEffectManager_Free_Address   0x4221F0
#define CSelectEffectManager_Create(p) \
	Ccall(p, CSelectEffectManager_Create_Address, void, ())()

// Cvbg}l[W\bh
#define CInputManager_ReadReplay(p, name) \
	Ccall(p, 0x42B6C0, bool,(char *))(name)

// xN^IuWFNg
#define Vector_Create \
	((void (__stdcall *)(void *, size_t, size_t, int, int))0x67BA4C)
#define Vector_Destruct \
	((void (__stdcall *)(void *, size_t, size_t, int))0x67B9E9)

// VXeL[Vbg
#define CheckKeyOneshot  \
	((bool(*)(int, int, int, int))0x4397F0)

// pbg[h
#define LoadPackagePalette(pflag, name, pal, bpp) \
	Ccall(pflag, 0x408F10, void, (LPCSTR, void *, int))(name, pal, bpp)

// LN^̎擾
#define GetCharacterAbbr \
	((LPCSTR (__cdecl *)(int id))0x43ABE0)

// og[hݒ
#define SetBattleMode \
	((void (__cdecl *)(int comm, int sub))0x43A560)

// pxcos
#define DegreeCosine \
    ((float (__cdecl *)(int deg))0x406680)

// eNX`}l[W
// CHandleManager<IDirect3DTexture *>
#define g_textureMgr ((void *)0x6ECD40)
// Direct3DfoCX
// IDirect3DDevice9*
#define g_pd3dDev    (*((IDirect3DDevice9**)0x6ED250))
// _
// CRenderer
#define g_renderer   ((void *)0x6E3DBC)
// lbg[NIuWFNg
// CNetworkServer/CNetworkClient
#define g_pnetObject (*(char**)0x6E62FC)
// vt@C
// char *
#define g_pprofP1 ((char*)(g_pnetObject + 0x04))
#define g_pprofP2 ((char*)(g_pnetObject + 0x24))
// UDPlbg[NIuWFNg
// CNetworkBase
#define g_pnetUdp    (g_pnetObject + 0x3B4)
// sA
// vector<SWRClientInfo> ?
#define g_psvClients (g_pnetUdp + 0xFC)
// T[oAhX
// in_addr
#define g_ptoAddr    (g_pnetUdp + 0x2C)
// og}l[W
// CBattleManager *
#define g_pbattleMgr (*(void **)0x6E6244)
// CtH}l[W
// CInfoManager *
#define g_pinfoMgr   (*(void **)0x6E6248)
// [h
// int
#define g_commMode   (*(DWORD*)0x6E62EC)
#define g_subMode    (*(DWORD*)0x6E62E4)
#define g_menuMode   (*(DWORD*)0x6D094C)
// V[ID
// DWORD
#define g_sceneIdNew (*(DWORD*)0x6ECE78)
#define g_sceneId    (*(DWORD*)0x6ECE7C)
// Ro[gf[^ptO
// bool
#define g_useCVxData (*(bool*)0x6ECE80)
// pbgIuWFNg
// void *
#define g_paletter   (*(void **)0x6E3DF8)
// Cvbg}l[W
// CInputManager ?
#define g_inputMgr   ((void *)0x6E6370)
// Cvbg}l[WNX^
// CInputManagerCluster
#define g_inputMgrs  ((void *)0x6E7520)
// LN^ID
// int
#define g_leftCharID (*(int*)0x6E6FF0)
#define g_rightCharID (*(int*)0x6E7010)
// argc/argv
#define __argc       (*(int*)0x6E7988)
#define __argv       (*(char***)0x6E798C)

// z֐e[u
#define vtbl_CLogo              0x6AC6FC
#define vtbl_Opening            0x6AC798
#define vtbl_CLoading           0x6AC6AC
#define vtbl_CTitle             0x6ACCF4
#define vtbl_CSelect            0x6ACBCC
#define vtbl_CSelectScenario    0x6ACC20
#define vtbl_CBattle            0x6AC470
#define vtbl_Ending             0x6AC5E8
#define vtbl_CSelectSV          0x6AC4AC
#define vtbl_CLoadingSV         0x6AC4CC
#define vtbl_CBattleSV          0x6AC4E8
#define vtbl_CSelectCL          0x6AC504
#define vtbl_CLoadingCL         0x6AC524
#define vtbl_CBattleCL          0x6AC540
#define vtbl_CLoadingWatch      0x6ACE68
#define vtbl_CBattleWatch       0x6AC55C
#define vtbl_CBattleManager     0x6AD50C

// NX\z֐caller
#define CLogo_Creater           0x41D827
#define Opening_Creater         0x41D861
#define CLoading_Creater        0x41D89B
#define CTitle_Creater          0x41D8D5
#define CSelect_Creater         0x41D90F
#define CSelectScenario_Creater 0x41D949
#define CBattle_Creater         0x41D980
#define Ending_Creater          0x41D9BA
#define CSelectSV_Creater       0x41D9F4
#define CLoadingSV_Creater      0x41DA2E
#define CBattleSV_Creater       0x41DA65
#define CSelectCL_Creater       0x41DA9F
#define CLoadingCL_Creater      0x41DAD9
#define CBattleCL_Creater       0x41DB10
#define CLoadingWatch_Creater   0x41DB46
#define CBattleWatch_Creater    0x41DB79
#define CBattleManager_Creater  0x437D90

// NXTCYIyh

#define CLogo_Size              (*(DWORD*)0x41D805)
#define Opening_Size            (*(DWORD*)0x41D83F)
#define CLoading_Size           (*(DWORD*)0x41D879)
#define CTitle_Size             (*(DWORD*)0x41D8B3)
#define CSelect_Size            (*(DWORD*)0x41D8ED)
#define CSelectScenario_Size    (*(DWORD*)0x41D927)
#define CBattle_Size            (*(BYTE *)0x41D961)
#define Ending_Size             (*(DWORD*)0x41D998)
#define CSelectSV_Size          (*(DWORD*)0x41D9D2)
#define CLoadingSV_Size         (*(DWORD*)0x41DA0C)
#define CBattleSV_Size          (*(BYTE *)0x41DA46)
#define CSelectCL_Size          (*(DWORD*)0x41DA7D)
#define CLoadingCL_Size         (*(DWORD*)0x41DAB7)
#define CBattleCL_Size          (*(BYTE *)0x41DAF1)
#define CLoadingWatch_Size      (*(DWORD*)0x41DB28)
#define CBattleWatch_Size       (*(BYTE *)0x41DB5E)
#define CBattleManager_Size     (*(DWORD*)0x437D72)

// ZNVTCY
#define text_Offset  0x401000
#define text_Size    0x2AB000
#define rdata_Offset 0x6AC000
#define rdata_Size   0x24000
#define data_Offset  0x6D0000
#define data_Size    0x1E5A8

// ---------------- ܂Ńev ----------------
#endif
